diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/civclient.c freeciv-patched/client/civclient.c
--- freeciv-cvs/client/civclient.c	2003-06-07 19:58:20.000000000 +0100
+++ freeciv-patched/client/civclient.c	2003-07-07 18:21:48.000000000 +0100
@@ -365,6 +365,15 @@
     handle_ruleset_unit((struct packet_ruleset_unit *)packet);
     break;
     
+  case PACKET_RULESET_MODIFIER_TYPE:
+    handle_ruleset_modifier_type(
+	(struct packet_ruleset_modifier_type *)packet);
+    break;
+    
+  case PACKET_RULESET_MODIFIER:
+    handle_ruleset_modifier((struct packet_ruleset_modifier *)packet);
+    break;
+    
   case PACKET_RULESET_TECH:
     handle_ruleset_tech((struct packet_ruleset_tech *)packet);
     break;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/menu.c freeciv-patched/client/gui-gtk/menu.c
--- freeciv-cvs/client/gui-gtk/menu.c	2003-06-26 20:13:14.000000000 +0100
+++ freeciv-patched/client/gui-gtk/menu.c	2003-07-07 18:21:48.000000000 +0100
@@ -79,6 +79,8 @@
   MENU_KINGDOM_TAX_RATE,
   MENU_KINGDOM_FIND_CITY,
   MENU_KINGDOM_WORKLISTS,
+  MENU_KINGDOM_WORKSHOP,
+  MENU_KINGDOM_ENGINEERING,
   MENU_KINGDOM_REVOLUTION,
 
   MENU_VIEW_SHOW_MAP_GRID,
@@ -211,6 +213,12 @@
   case MENU_KINGDOM_WORKLISTS:
     popup_worklists_report(game.player_ptr);
     break;
+  case MENU_KINGDOM_WORKSHOP:
+    popup_workshop_dialog();
+    break;
+  case MENU_KINGDOM_ENGINEERING:
+    popup_engineering_dialog();
+    break;
   case MENU_KINGDOM_REVOLUTION:
     popup_revolution_dialog();
     break;
@@ -598,6 +606,12 @@
 	kingdom_menu_callback,	MENU_KINGDOM_WORKLISTS					},
   { "/" N_("Kingdom") "/sep2",				NULL,
 	NULL,			0,					"<Separator>"	},
+  { "/" N_("Kingdom") "/" N_("Design _Workshop"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_WORKSHOP					},
+  { "/" N_("Kingdom") "/" N_("Social _Engineering"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_ENGINEERING					},
+  { "/" N_("Kingdom") "/sep3",				NULL,
+	NULL,			0,					"<Separator>"	},
   { "/" N_("Kingdom") "/" N_("_Government"),  NULL,
 	NULL,           0,                  "<Branch>"    },
   { "/" N_("Kingdom") "/" N_("_Government") "/" N_("_Revolution!"),
@@ -1033,6 +1047,10 @@
     }
 
     menus_set_sensitive("<main>/_Reports", TRUE);
+    menus_set_sensitive("<main>/_Kingdom/Design _Workshop",
+			game.num_unit_modifier_types > 0);
+    menus_set_sensitive("<main>/_Kingdom/Social _Engineering",
+			game.num_gov_modifier_types > 0);
     menus_set_sensitive("<main>/_Kingdom", TRUE);
     menus_set_sensitive("<main>/_View", TRUE);
     menus_set_sensitive("<main>/_Orders", can_client_issue_orders());
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/menu.c freeciv-patched/client/gui-gtk-2.0/menu.c
--- freeciv-cvs/client/gui-gtk-2.0/menu.c	2003-06-26 20:13:14.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/menu.c	2003-07-07 18:21:48.000000000 +0100
@@ -80,6 +80,8 @@
   MENU_KINGDOM_TAX_RATE,
   MENU_KINGDOM_FIND_CITY,
   MENU_KINGDOM_WORKLISTS,
+  MENU_KINGDOM_WORKSHOP,
+  MENU_KINGDOM_ENGINEERING,
   MENU_KINGDOM_REVOLUTION,
 
   MENU_VIEW_SHOW_MAP_GRID,
@@ -212,6 +214,12 @@
   case MENU_KINGDOM_WORKLISTS:
     popup_worklists_report();
     break;
+  case MENU_KINGDOM_WORKSHOP:
+    popup_workshop_dialog();
+    break;
+  case MENU_KINGDOM_ENGINEERING:
+    popup_engineering_dialog();
+    break;
   case MENU_KINGDOM_REVOLUTION:
     popup_revolution_dialog();
     break;
@@ -597,6 +605,12 @@
 	kingdom_menu_callback,	MENU_KINGDOM_WORKLISTS					},
   { "/" N_("Kingdom") "/sep2",				NULL,
 	NULL,			0,					"<Separator>"	},
+  { "/" N_("Kingdom") "/" N_("Design _Workshop"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_WORKSHOP					},
+  { "/" N_("Kingdom") "/" N_("Social _Engineering"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_ENGINEERING					},
+  { "/" N_("Kingdom") "/sep3",				NULL,
+	NULL,			0,					"<Separator>"	},
   { "/" N_("_Kingdom") "/" N_("_Government"),           NULL,
 	NULL,			0,					"<Branch>"	},
   { "/" N_("Kingdom") "/" N_("_Government") "/" N_("_Revolution"),
@@ -1052,6 +1066,10 @@
     }
 
     menus_set_sensitive("<main>/_Reports", TRUE);
+    menus_set_sensitive("<main>/_Kingdom/Design _Workshop",
+			game.num_unit_modifier_types > 0);
+    menus_set_sensitive("<main>/_Kingdom/Social _Engineering",
+			game.num_gov_modifier_types > 0);
     menus_set_sensitive("<main>/_Kingdom", TRUE);
     menus_set_sensitive("<main>/_View", TRUE);
     menus_set_sensitive("<main>/_Orders", can_client_issue_orders());
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/helpdata.c freeciv-patched/client/helpdata.c
--- freeciv-cvs/client/helpdata.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/client/helpdata.c	2003-07-07 18:22:00.000000000 +0100
@@ -714,9 +714,13 @@
 	strcat(astr.str, deli_str);
       }
     }
-    
-    assert(num_allowed_units > 0);
 
+    if (num_allowed_units == 0) {
+      char *deli_str = _("carrier unit");
+      astr_minsize(&astr, strlen(deli_str));
+      strcpy(astr.str, deli_str);
+    }
+    
     sprintf(buf + strlen(buf),
 	    PL_("* Unit has to be in a city, or on a %s"
 		" after %d turn.\n",
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/include/dialogs_g.h freeciv-patched/client/include/dialogs_g.h
--- freeciv-cvs/client/include/dialogs_g.h	2002-11-29 12:25:10.000000000 +0000
+++ freeciv-patched/client/include/dialogs_g.h	2003-07-07 18:21:48.000000000 +0100
@@ -15,10 +15,9 @@
 
 #include "shared.h"		/* bool type */
 #include "terrain.h"		/* enum tile_special_type */
+#include "unittype.h"		/* Unit_Type_id type */
 
 struct tile;
-struct unit;
-struct city;
 struct packet_nations_used;
 
 void popup_notify_goto_dialog(char *headline, char *lines, int x, int y);
@@ -33,6 +32,9 @@
 
 void popup_revolution_dialog(void);
 void popup_government_dialog(void);
+void popup_workshop_dialog(void);
+void popup_engineering_dialog(void);
+void workshop_dialog_update(Unit_Type_id id);
 void popup_caravan_dialog(struct unit *punit,
 			  struct city *phomecity, struct city *pdestcity);
 bool caravan_dialog_is_open(void);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/Makefile.am freeciv-patched/client/Makefile.am
--- freeciv-cvs/client/Makefile.am	2003-06-07 19:58:19.000000000 +0100
+++ freeciv-patched/client/Makefile.am	2003-07-07 18:21:48.000000000 +0100
@@ -185,4 +185,4 @@
 civclient_LDADD        = @gui_sources@/libguiclient.a \
 	@INTLLIBS@ ../common/aicore/libaicore.a \
         ../common/libcivcommon.a agents/libagents.a \
-	@CLIENT_LIBS@ @SOUND_LIBS@
+	@CLIENT_LIBS@ @SOUND_LIBS@ -lslang-utf8
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/packhand.c freeciv-patched/client/packhand.c
--- freeciv-cvs/client/packhand.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/client/packhand.c	2003-07-07 18:21:48.000000000 +0100
@@ -1945,6 +1945,25 @@
   game.num_impr_types = packet->num_impr_types;
   game.num_tech_types = packet->num_tech_types;
 
+  game.num_unit_modifier_types = packet->num_unit_modifier_types;
+  game.num_unit_modifiers = packet->num_unit_modifiers;
+  game.num_gov_modifier_types = packet->num_gov_modifier_types;
+  game.num_gov_modifiers = packet->num_gov_modifiers;
+
+  if (game.num_unit_modifiers > 0) {
+    unit_modifiers = fc_calloc(game.num_unit_modifiers,
+			       sizeof(struct modifier));
+  } else {
+    unit_modifiers = NULL;
+  }
+
+  if (game.num_gov_modifiers > 0) {
+    gov_modifiers = fc_calloc(game.num_gov_modifiers,
+			      sizeof(struct modifier));
+  } else {
+    gov_modifiers = NULL;
+  }
+
   governments_alloc(packet->government_count);
 
   nations_alloc(packet->nation_count);
@@ -1965,12 +1984,17 @@
 void handle_ruleset_unit(struct packet_ruleset_unit *p)
 {
   struct unit_type *u;
+  int i;
 
-  if(p->id < 0 || p->id >= game.num_unit_types || p->id >= U_LAST) {
+  if(p->id < 0 || p->id >= U_LAST) {
     freelog(LOG_ERROR, "Received bad unit_type id %d in handle_ruleset_unit()",
 	    p->id);
     return;
   }
+  if (p->id >= game.num_unit_types) {
+    freelog(LOG_NORMAL, "Number of unit types increased to %d", p->id + 1);
+    game.num_unit_types = p->id + 1;
+  }
   u = get_unit_type(p->id);
 
   sz_strlcpy(u->name, p->name);
@@ -2006,9 +2030,72 @@
   u->paratroopers_mr_sub = p->paratroopers_mr_sub;
   u->effect             = p->effect;  /* pointer assignment */
 
+  u->basetype         = p->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    u->modifiers[i]   = p->modifiers[i];
+  }
+
   u->helptext = p->helptext;	/* pointer assignment */
 
   tilespec_setup_unit_type(p->id);
+
+  workshop_dialog_update(p->id);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+void handle_ruleset_modifier_type(
+    struct packet_ruleset_modifier_type *p)
+{
+  struct modifier_type *u;
+  int max_mod;
+
+  max_mod = (p->is_gov ? game.num_gov_modifier_types
+      		       : game.num_unit_modifier_types);
+
+  if (p->id < 0 || p->id >= max_mod) {
+    freelog(LOG_ERROR, "Received bad modifier type id %d in "
+                     "handle_ruleset_modifier_type()", p->id);
+    return;
+  }
+  if (p->is_gov) {
+    u = &gov_modifier_types[p->id];
+  } else {
+    u = &unit_modifier_types[p->id];
+  }
+  sz_strlcpy(u->name, p->name);
+  u->id = p->basetype;
+  u->tech_requirement = p->tech_requirement;
+  u->must_use = p->must_use;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+void handle_ruleset_modifier(struct packet_ruleset_modifier *p)
+{
+  struct modifier *u;
+  int max_mod;
+
+  max_mod = (p->is_gov ? game.num_gov_modifiers
+      		       : game.num_unit_modifiers);
+
+  if (p->id < 0 || p->id >= max_mod) {
+    freelog(LOG_ERROR,
+      "Received bad modifier id %d in handle_ruleset_modifier()",
+      p->id);
+    return;
+  }
+  if (p->is_gov) {
+    u = &gov_modifiers[p->id];
+  } else {
+    u = &unit_modifiers[p->id];
+  }
+  sz_strlcpy(u->name, p->name);
+  u->type = p->type;
+  u->tech_requirement = p->tech_requirement;
+  u->effect = p->effect;	/* pointer assignment */
 }
 
 /**************************************************************************
@@ -2211,13 +2298,21 @@
 void handle_ruleset_government(struct packet_ruleset_government *p)
 {
   struct government *gov;
+  int i;
 
-  if (p->id < 0 || p->id >= game.government_count) {
+  if (p->id < 0 || p->id >= G_MAGIC) {
     freelog(LOG_ERROR,
 	    "Received bad government id %d in handle_ruleset_government",
 	    p->id);
     return;
   }
+  if (p->id >= game.government_count) {
+    freelog(LOG_NORMAL, "Number of gov types increased to %d", p->id + 1);
+    game.government_count = p->id + 1;
+    governments = (struct government *)fc_realloc(governments,
+        					  game.government_count
+                                                  * sizeof(struct government));
+  }
   gov = &governments[p->id];
 
   gov->index             = p->id;
@@ -2230,6 +2325,11 @@
   gov->empire_size_mod   = p->empire_size_mod;
   gov->empire_size_inc   = p->empire_size_inc;
   gov->rapture_size      = p->rapture_size;
+  gov->basetype		 = p->basetype;
+
+  for (i = 0; i < MAX_MODS; ++i) {
+    gov->modifiers[i]    = p->modifiers[i];
+  }
   
   gov->unit_happy_cost_factor  = p->unit_happy_cost_factor;
   gov->unit_shield_cost_factor = p->unit_shield_cost_factor;
@@ -2286,6 +2386,13 @@
   gov->helptext = p->helptext;	/* pointer assignment */
   
   tilespec_setup_government(p->id);
+
+  /* If we're getting governments re-sent after the game has started,
+   * then this generally means a player has changed government, and
+   * thus an effect update is needed. */
+  if(get_client_state()==CLIENT_GAME_RUNNING_STATE) {
+    update_all_effects();
+  }
 }
 void handle_ruleset_government_ruler_title
   (struct packet_ruleset_government_ruler_title *p)
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/packhand.h freeciv-patched/client/packhand.h
--- freeciv-cvs/client/packhand.h	2003-06-27 15:51:10.000000000 +0100
+++ freeciv-patched/client/packhand.h	2003-07-07 18:21:49.000000000 +0100
@@ -47,6 +47,9 @@
 void handle_remove_player(struct packet_generic_integer *packet);
 void handle_ruleset_control(struct packet_ruleset_control *packet);
 void handle_ruleset_unit(struct packet_ruleset_unit *p);
+void handle_ruleset_modifier_type(
+    struct packet_ruleset_modifier_type *p);
+void handle_ruleset_modifier(struct packet_ruleset_modifier *p);
 void handle_ruleset_tech(struct packet_ruleset_tech *p);
 void handle_ruleset_building(struct packet_ruleset_building *p);
 void handle_ruleset_terrain(struct packet_ruleset_terrain *p);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/capstr.c freeciv-patched/common/capstr.c
--- freeciv-cvs/common/capstr.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/capstr.c	2003-07-07 18:21:49.000000000 +0100
@@ -78,7 +78,7 @@
                    "city_struct_minor_cleanup obsolete_last class_legend " \
                    "+impr_req +waste +fastfocus +continent +small_dipl " \
                    "+no_nation_selected +diplomacy +no_extra_tiles " \
-                   "+diplomacy2 +citizens_style +root_tech impr_gen"
+                   "+diplomacy2 +citizens_style +root_tech impr_gen compounds"
 
 /* "+1.14.0" is protocol for 1.14.0 release.
  *
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/game.h freeciv-patched/common/game.h
--- freeciv-cvs/common/game.h	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/game.h	2003-07-07 18:21:49.000000000 +0100
@@ -152,6 +152,10 @@
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;  /* including A_NONE */
+  int num_unit_modifier_types;
+  int num_unit_modifiers;
+  int num_gov_modifier_types;
+  int num_gov_modifiers;
 
   int government_count;
   int default_government;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.c freeciv-patched/common/government.c
--- freeciv-cvs/common/government.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/government.c	2003-07-07 18:21:49.000000000 +0100
@@ -19,10 +19,12 @@
 #include <stdlib.h>
 #include <string.h>
 
+#include "fcintl.h"
 #include "game.h"
 #include "log.h"
 #include "mem.h"
 #include "player.h"
+#include "script.h"
 #include "shared.h"
 #include "support.h"
 #include "tech.h"
@@ -59,6 +61,8 @@
  */
 
 struct government *governments = NULL;
+struct modifier_type gov_modifier_types[MAX_MODS];
+struct modifier *gov_modifiers = NULL;
 
 struct ai_gov_tech_hint ai_gov_tech_hints[MAX_NUM_TECH_LIST];
 
@@ -66,7 +70,7 @@
   "(unused)", "Revolution_When_Unhappy", "Has_Senate",
   "Unbribable", "Inspires_Partisans", "Rapture_City_Growth",
   "Fanatic_Troops", "No_Unhappy_Citizens", "Convert_Tithes_To_Money",
-  "Reduced_Research"
+  "Reduced_Research", "CanModify"
 };
 static const char *hint_names[] = {
   "Is_Nice", "Favors_Growth"
@@ -142,6 +146,25 @@
   return NULL;
 }
 
+int find_gov_modifier_by_name(const char *s)
+{
+  return find_modifier_by_name(s, gov_modifiers, game.num_gov_modifiers);
+}
+
+bool government_has_modifier(struct government *gov, int govmod)
+{
+  if (gov && gov->basetype != G_MAGIC) {
+    int i;
+
+    for (i = 0; i < game.num_gov_modifier_types; ++i) {
+      if (gov->modifiers[i] == govmod) {
+	return TRUE;
+      }
+    }
+  }
+  return FALSE;
+}
+
 /***************************************************************
 ...
 ***************************************************************/
@@ -324,3 +347,95 @@
   governments = NULL;
   game.government_count = 0;
 }
+
+/***************************************************************
+...
+***************************************************************/
+static void copy_government(struct government *dest, struct government *src)
+{
+  int i;
+
+  memcpy(dest, src, sizeof(struct government));
+
+  dest->effect = NULL;
+  append_effects(&dest->effect, src->effect);
+
+  dest->num_ruler_titles = src->num_ruler_titles;
+  dest->ruler_titles = fc_calloc(dest->num_ruler_titles,
+      				 sizeof(struct ruler_title));
+  for (i = 0; i < dest->num_ruler_titles; i++) {
+    struct ruler_title *fromtitle = &(src->ruler_titles[i]);
+    struct ruler_title *totitle = &(dest->ruler_titles[i]);
+
+    totitle->nation = fromtitle->nation;
+    sz_strlcpy(totitle->male_title, fromtitle->male_title);
+    sz_strlcpy(totitle->female_title, fromtitle->female_title);
+  }
+
+  dest->helptext = src->helptext ? mystrdup(src->helptext) : NULL;
+}
+
+/***************************************************************
+...
+***************************************************************/
+int form_compound_gov(struct player *pplayer, const char *name,
+    		      const int basetype, const int modifiers[MAX_MODS])
+{
+  struct government *gov = NULL, *base;
+  struct modifier *mod;
+  char buffer[200];
+  int id = -1, i;
+
+  if (pplayer) {
+    id = pplayer->government;
+    gov = get_gov_pplayer(pplayer);
+  }
+  if (!pplayer || gov->basetype == G_MAGIC) {
+    id = game.government_count++;
+    if (id >= G_MAGIC) {
+      freelog(LOG_FATAL, "form_compound_gov: out of government types");
+      exit(EXIT_FAILURE);
+    }
+
+    governments = (struct government *)fc_realloc(governments,
+						  game.government_count
+						  * sizeof(struct government));
+    gov = &governments[id];
+  } else if (pplayer) {
+    government_free(gov);
+  }
+  base = &governments[basetype];
+  copy_government(gov, base);
+  gov->index = id;
+  gov->basetype = basetype;
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    gov->modifiers[i] = modifiers[i];
+  }
+  gov->required_tech = A_NONE;
+  gov->name_orig[0] = '\0';
+  my_snprintf(buffer, sizeof(buffer),
+	      "variable gt = get_gov(%d);", id);
+  script_execute(buffer);
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    if (gov->modifiers[i] < U_LAST) {
+      mod = &gov_modifiers[gov->modifiers[i]];
+      script_execute(mod->action);
+    }
+  }
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    if (gov->modifiers[i] < U_LAST) {
+      mod = &gov_modifiers[gov->modifiers[i]];
+      script_execute(mod->final_action);
+      append_effects(&gov->effect, mod->effect);
+    }
+  }
+  my_snprintf(buffer, sizeof(buffer),
+	      "set_gov(%d, gt);", id);
+  script_execute(buffer);
+  if (name && name[0]) {
+    sz_strlcpy(gov->name_orig, name);
+    sz_strlcpy(gov->name, _(gov->name_orig));
+  }
+
+  return id;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.h freeciv-patched/common/government.h
--- freeciv-cvs/common/government.h	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/government.h	2003-07-07 18:21:49.000000000 +0100
@@ -14,6 +14,7 @@
 #define FC__GOVERNMENT_H
 
 #include "shared.h"
+#include "modifier.h"
 
 struct city;
 struct player;
@@ -39,6 +40,7 @@
   G_CONVERT_TITHES_TO_MONEY,    /* tithes to money, needed by fundamentalism */
   G_REDUCED_RESEARCH,           /* penalty for research, needed by
 				   fundamentalism */
+  G_CAN_MODIFY,			/* can apply government modifiers */
   G_LAST_FLAG
 };
 #define G_FIRST_FLAG G_BUILD_VETERAN_DIPLOMAT
@@ -156,6 +158,9 @@
   struct Sprite *sprite;
 
   struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+
+  int basetype;		/* if !G_MAGIC, government modifiers are applied */
+  int modifiers[MAX_MODS];
   
   char *helptext;
 };
@@ -172,6 +177,8 @@
 };
 
 extern struct government *governments;
+extern struct modifier_type gov_modifier_types[MAX_MODS];
+extern struct modifier *gov_modifiers;
 
 extern struct ai_gov_tech_hint ai_gov_tech_hints[MAX_NUM_TECH_LIST];
 /* like game.rtech lists, A_LAST terminated (for .tech)
@@ -182,6 +189,8 @@
 struct government *get_gov_pcity(struct city *pcity);
 
 struct government *find_government_by_name(const char *name);
+int find_gov_modifier_by_name(const char *s);
+bool government_has_modifier(struct government *gov, int govmod);
 
 enum government_flag_id government_flag_from_str(const char *s);
 bool government_has_flag(const struct government *gov,
@@ -201,6 +210,8 @@
                      const char *male, const char *female);
 void governments_alloc(int num);
 void governments_free(void);
+int form_compound_gov(struct player *pplayer, const char *name,
+    		      const int basetype, const int modifiers[MAX_MODS]);
 
 #define government_iterate(gov)                                             \
 {                                                                           \
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.c freeciv-patched/common/improvement.c
--- freeciv-cvs/common/improvement.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/improvement.c	2003-07-07 18:21:49.000000000 +0100
@@ -1035,6 +1035,12 @@
     freelog(LOG_DEBUG, "Effect requires a government");
     return FALSE;
   }
+  if (imeff->cond_govmod != game.num_gov_modifiers && pplayer
+      && !government_has_modifier(get_gov_pplayer(pplayer),
+				  imeff->cond_govmod)) {
+    freelog(LOG_DEBUG, "Effect requires a government modifier");
+    return FALSE;
+  }
   if (pplayer && get_invention(pplayer, imeff->cond_adv) != TECH_KNOWN) {
     freelog(LOG_DEBUG, "Effect requires a future tech");
     return FALSE;
@@ -1457,3 +1463,30 @@
     }
   }
 }
+
+void append_effects(struct impr_effect **dest, struct impr_effect *src)
+{
+  int numsrc = 0, numdest = 0, numeff;
+  struct impr_effect *eff;
+
+  for (eff = *dest; eff && eff->type != EFT_LAST; ++eff) {
+    numdest++;
+  }
+  for (eff = src; eff && eff->type != EFT_LAST; ++eff) {
+    numsrc++;
+  }
+  numeff = numdest + numsrc;
+
+  if (numeff > MAX_EFFECTS) {
+    freelog(LOG_FATAL, "MAX_EFFECTS exceeded");
+    exit(EXIT_FAILURE);
+  }
+
+  if (numsrc) {
+    *dest = fc_realloc(*dest, (numeff + 1) * sizeof(struct impr_effect));
+    memcpy(*dest + numdest, src, (numsrc + 1) * sizeof(struct impr_effect));
+  } else if (!*dest) {
+    *dest = fc_malloc(sizeof(struct impr_effect));
+    (*dest)->type = EFT_LAST;
+  }
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.h freeciv-patched/common/improvement.h
--- freeciv-cvs/common/improvement.h	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/improvement.h	2003-07-07 18:21:49.000000000 +0100
@@ -201,6 +201,7 @@
 					 * center tile */
   Impr_Type_id cond_bldg;	   /* B_LAST = unconditional */
   int cond_gov;			   /* game.government_count = unconditional */
+  int cond_govmod;		   /* game.num_gov_modifiers = unconditional */
   Tech_Type_id cond_adv;	   /* A_NONE = unconditional; A_LAST = never */
   enum effect_type cond_eff;	   /* EFT_LAST = unconditional */
   Unit_Class_id aff_unit;	   /* UCL_LAST = all */
@@ -440,6 +441,7 @@
 struct ceff_vector *get_eff_city(struct city *pcity);
 void remove_global_effects(Impr_Type_id impr, struct player *pplayer);
 void add_global_effects(Impr_Type_id impr, struct player *pplayer);
+void append_effects(struct impr_effect **dest, struct impr_effect *src);
 
 void allot_island_improvs(void);
 void improvements_update_obsolete(void);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/Makefile.am freeciv-patched/common/Makefile.am
--- freeciv-cvs/common/Makefile.am	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/Makefile.am	2003-07-07 18:21:49.000000000 +0100
@@ -63,12 +63,16 @@
 		pqueue.h	\
 		mem.c           \
 		mem.h		\
+		modifier.c	\
+		modifier.h	\
 		rand.c		\
 		rand.h		\
 		registry.c	\
 		registry.h	\
 		sbuffer.c	\
 		sbuffer.h	\
+		script.c	\
+		script.h	\
 		shared.c	\
 		shared.h	\
 		spaceship.c	\
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/modifier.c freeciv-patched/common/modifier.c
--- freeciv-cvs/common/modifier.c	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/modifier.c	2003-07-07 18:21:49.000000000 +0100
@@ -0,0 +1,56 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string.h>
+
+#include "modifier.h"
+#include "shared.h"
+#include "support.h"
+
+/**************************************************************************
+  Convert modifier_type names to int; case insensitive;
+  returns -1 if can't match.
+**************************************************************************/
+int modifier_type_from_str(const char *s,
+    			   struct modifier_type *modifier_types,
+			   int num_mod_types)
+{
+  int i;
+  for (i = 0; i < num_mod_types; ++i) {
+    if (mystrcasecmp(modifier_types[i].name, s) == 0) {
+      return i;
+    }
+  }
+  return -1;
+}
+
+/**************************************************************************
+Does a linear search of modifiers[].name
+Returns -1 if none match.
+**************************************************************************/
+int find_modifier_by_name(const char *s,
+    			  struct modifier *modifiers,
+			  int num_mods)
+{
+  int i;
+  for (i = 0; i < num_mods; ++i) {
+    if (mystrcasecmp(modifiers[i].name, s) == 0) {
+      return i;
+    }
+  }
+  return -1;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/modifier.h freeciv-patched/common/modifier.h
--- freeciv-cvs/common/modifier.h	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/modifier.h	2003-07-07 18:21:49.000000000 +0100
@@ -0,0 +1,48 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+#ifndef FC__MODIFIER_H
+#define FC__MODIFIER_H
+
+#include "shared.h"
+
+struct impr_effect;
+
+/* Maximum number of modifier types */
+#define MAX_MODS 16
+
+struct modifier {
+  char name[MAX_LEN_NAME];
+  int type;
+  int tech_requirement;
+  int obsoleted_by;
+  char *action;
+  char *final_action;
+  struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+};
+  
+struct modifier_type {
+  char name[MAX_LEN_NAME];
+  int id;
+  int tech_requirement;
+  int obsoleted_by;
+  bool must_use;
+};
+
+int modifier_type_from_str(const char *s,
+    			   struct modifier_type *modifier_types,
+			   int num_mod_types);
+int find_modifier_by_name(const char *s,
+    			  struct modifier *modifiers,
+			  int num_mods);
+
+#endif  /* FC__MODIFIER_H */
